"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var stream_1 = require("stream");
var ts_packet_1 = require("./ts-packet");
var PacketChunker = /** @class */ (function (_super) {
    __extends(PacketChunker, _super);
    function PacketChunker() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.ascendant = Buffer.from([]);
        return _this;
    }
    PacketChunker.prototype._transform = function (chunk, encoding, callback) {
        var processing = Buffer.concat([this.ascendant, chunk]);
        var lastSyncBytePosition = -1;
        for (var i = 0; i < processing.length; i++) {
            if (processing[i] != ts_packet_1.SYNC_BYTE) {
                continue;
            }
            lastSyncBytePosition = i;
            if (i + ts_packet_1.PACKET_SIZE <= processing.length) {
                this.push(processing.slice(i, i + ts_packet_1.PACKET_SIZE));
                lastSyncBytePosition = -1;
            }
            i += ts_packet_1.PACKET_SIZE - 1;
        }
        if (lastSyncBytePosition >= 0) {
            this.ascendant = processing.slice(lastSyncBytePosition);
        }
        else {
            this.ascendant = Buffer.from([]);
        }
        callback();
    };
    PacketChunker.prototype._flush = function (callback) {
        callback();
    };
    return PacketChunker;
}(stream_1.Transform));
exports.default = PacketChunker;
