"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ts_packet_1 = require("./ts-packet");
var PacketQueue = /** @class */ (function () {
    function PacketQueue() {
        this.queue = [];
        this.ascendant = Buffer.from([]);
    }
    PacketQueue.prototype.push = function (chunk) {
        var processing = Buffer.concat([this.ascendant, chunk]);
        var lastSyncBytePosition = -1;
        for (var i = 0; i < processing.length; i++) {
            if (processing[i] != ts_packet_1.SYNC_BYTE) {
                continue;
            }
            lastSyncBytePosition = i;
            if (i + ts_packet_1.PACKET_SIZE <= processing.length) {
                this.queue.push(processing.slice(i, i + ts_packet_1.PACKET_SIZE));
                lastSyncBytePosition = -1;
            }
            i += ts_packet_1.PACKET_SIZE - 1;
        }
        if (lastSyncBytePosition >= 0) {
            this.ascendant = processing.slice(lastSyncBytePosition);
        }
        else {
            this.ascendant = Buffer.from([]);
        }
    };
    PacketQueue.prototype.pop = function () {
        return this.queue.shift();
    };
    PacketQueue.prototype.isEmpty = function () {
        return this.queue.length === 0;
    };
    PacketQueue.prototype.clear = function () {
        this.ascendant = Buffer.from([]);
        this.queue.length = 0;
    };
    return PacketQueue;
}());
exports.default = PacketQueue;
