"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pcr = exports.has_pcr = exports.pointer_field = exports.adaptation_field_length = exports.continuity_counter = exports.has_payload = exports.has_adaptation_field = exports.transport_scrambling_control = exports.pid = exports.transport_priority = exports.payload_unit_start_indicator = exports.transport_error_indicator = exports.STUFFING_BYTE = exports.SYNC_BYTE = exports.HEADER_SIZE = exports.PACKET_SIZE = void 0;
exports.PACKET_SIZE = 188;
exports.HEADER_SIZE = 4;
exports.SYNC_BYTE = 0x47;
exports.STUFFING_BYTE = 0xFF;
var transport_error_indicator = function (packet) {
    return (packet[1] & 0x80) != 0;
};
exports.transport_error_indicator = transport_error_indicator;
var payload_unit_start_indicator = function (packet) {
    return (packet[1] & 0x40) != 0;
};
exports.payload_unit_start_indicator = payload_unit_start_indicator;
var transport_priority = function (packet) {
    return (packet[1] & 0x20) != 0;
};
exports.transport_priority = transport_priority;
var pid = function (packet) {
    return ((packet[1] & 0x1F) << 8) | packet[2];
};
exports.pid = pid;
var transport_scrambling_control = function (packet) {
    return (packet[3] & 0xC0) >> 6;
};
exports.transport_scrambling_control = transport_scrambling_control;
var has_adaptation_field = function (packet) {
    return (packet[3] & 0x20) != 0;
};
exports.has_adaptation_field = has_adaptation_field;
var has_payload = function (packet) {
    return (packet[3] & 0x10) != 0;
};
exports.has_payload = has_payload;
var continuity_counter = function (packet) {
    return packet[3] & 0x0F;
};
exports.continuity_counter = continuity_counter;
var adaptation_field_length = function (packet) {
    return exports.has_adaptation_field(packet) ? packet[4] : 0;
};
exports.adaptation_field_length = adaptation_field_length;
var pointer_field = function (packet) {
    return packet[exports.HEADER_SIZE + (exports.has_adaptation_field(packet) ? 1 + exports.adaptation_field_length(packet) : 0)];
};
exports.pointer_field = pointer_field;
var has_pcr = function (packet) {
    return exports.has_adaptation_field(packet) && (packet[exports.HEADER_SIZE + 1] & 0x10) != 0;
};
exports.has_pcr = has_pcr;
var pcr = function (packet) {
    if (!exports.has_pcr(packet)) {
        return Number.NaN;
    }
    var pcr_base = 0;
    pcr_base = (pcr_base * (1 << 8)) + ((packet[exports.HEADER_SIZE + 1 + 1] & 0xFF) >> 0);
    pcr_base = (pcr_base * (1 << 8)) + ((packet[exports.HEADER_SIZE + 1 + 2] & 0xFF) >> 0);
    pcr_base = (pcr_base * (1 << 8)) + ((packet[exports.HEADER_SIZE + 1 + 3] & 0xFF) >> 0);
    pcr_base = (pcr_base * (1 << 8)) + ((packet[exports.HEADER_SIZE + 1 + 4] & 0xFF) >> 0);
    pcr_base = (pcr_base * (1 << 1)) + ((packet[exports.HEADER_SIZE + 1 + 5] & 0x10) >> 7);
    return pcr_base;
};
exports.pcr = pcr;
