"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ts_packet_1 = require("./ts-packet");
var SectionPacketizer = /** @class */ (function () {
    function SectionPacketizer() {
    }
    SectionPacketizer.packetize = function (section, transport_error_indicator, transport_priority, pid, transport_scrambling_control, continuity_counter) {
        var result = [];
        var begin = 0;
        while (begin < section.length) {
            var header = Buffer.from([
                ts_packet_1.SYNC_BYTE,
                ((transport_error_indicator ? 1 : 0) << 7) | ((begin === 0 ? 1 : 0) << 6) | ((transport_priority ? 1 : 0) << 5) | ((pid & 0x1F00) >> 8),
                (pid & 0x00FF),
                (transport_scrambling_control << 6) | (1 << 4) | (continuity_counter & 0x0F),
            ]);
            continuity_counter = (continuity_counter + 1) & 0x0F;
            var next = Math.min(section.length, begin + ((ts_packet_1.PACKET_SIZE - ts_packet_1.HEADER_SIZE) - (begin === 0 ? 1 : 0)));
            var payload = section.slice(begin, next);
            if (begin === 0) {
                payload = Buffer.concat([Buffer.alloc(1), payload]);
            }
            var fillStuffingSize = Math.max(0, ts_packet_1.PACKET_SIZE - (ts_packet_1.HEADER_SIZE + payload.length));
            payload = Buffer.concat([payload, Buffer.alloc(fillStuffingSize, ts_packet_1.STUFFING_BYTE)]);
            var packet = Buffer.concat([header, payload]);
            result.push(packet);
            begin = next;
        }
        return result;
    };
    return SectionPacketizer;
}());
exports.default = SectionPacketizer;
