"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CRC32 = exports.last_section_number = exports.section_number = exports.current_next_indicator = exports.version_number = exports.table_id_extension = exports.section_length = exports.table_id = exports.CRC_SIZE = exports.EXTENDED_HEADER_SIZE = exports.BASIC_HEADER_SIZE = void 0;
exports.BASIC_HEADER_SIZE = 3;
exports.EXTENDED_HEADER_SIZE = 8;
exports.CRC_SIZE = 4;
var table_id = function (section) {
    return section[0];
};
exports.table_id = table_id;
var section_length = function (section) {
    return ((section[1] & 0x0F) << 8) | section[2];
};
exports.section_length = section_length;
var table_id_extension = function (section) {
    return (section[3] << 8) | section[4];
};
exports.table_id_extension = table_id_extension;
var version_number = function (section) {
    return (section[5] & 0x3E) >> 1;
};
exports.version_number = version_number;
var current_next_indicator = function (section) {
    return (section[5] & 0x01) != 0;
};
exports.current_next_indicator = current_next_indicator;
var section_number = function (section) {
    return section[6];
};
exports.section_number = section_number;
var last_section_number = function (section) {
    return section[7];
};
exports.last_section_number = last_section_number;
var CRC32 = function (section) {
    var crc = 0xFFFFFFFF;
    for (var i = 0; i < section.length; i++) {
        var byte = section[i];
        for (var index = 7; index >= 0; index--) {
            var bit = (byte & (1 << index)) >> index;
            var c = (crc & 0x80000000) != 0 ? 1 : 0;
            crc <<= 1;
            if (c ^ bit) {
                crc ^= 0x04c11db7;
            }
            crc &= 0xFFFFFFFF;
        }
    }
    return crc;
};
exports.CRC32 = CRC32;
